<template>
  <div class="group-modal">
    <div class="flex gap-[70px]">
      <div
        v-for="(option, index) in tab_options"
        :key="index"
        :class="{
          'text-xl font-semibold cursor-pointer': true,
          'text-primary': tab === option,
        }"
        @click="changeTab(option)"
      >
        {{ option }}
      </div>
    </div>

    <div class="border-primary border rounded-md mt-4">
      <template v-if="tab === 'ควบคุม'">
        <div class="grid grid-cols-2 grid-rows-2 relative">
          <div class="border-r border-b border-primary p-4">
            <div class="text-xl font-semibold">การเปิด-ปิดไฟ</div>

            <div class="flex gap-10 justify-center items-center mt-10">
              <div class="text-center">
                <div class="w-[90px]">
                  <img
                    v-if="form.status"
                    :src="require('~/assets/images/Group 759.svg')"
                    alt="Group 759.svg"
                    class="w-full"
                  />

                  <img
                    v-else
                    :src="require('~/assets/images/street-light (2) 2.svg')"
                    alt="street-light (2) 2.svg"
                    class="w-full"
                  />
                </div>

                <div class="text-yellow mt-2">{{ form.name || "Name" }}</div>
              </div>

              <div
                class="cursor-pointer w-[140px]"
                @click="form.status = !form.status"
              >
                <img
                  v-if="form.status"
                  :src="require('~/assets/images/Group 1033 (1).svg')"
                  alt="Group 1033 (1).svg"
                  class="w-full"
                />

                <img
                  v-else
                  :src="require('~/assets/images/Group 1033.svg')"
                  alt="Group 1033.svg"
                  class="w-full"
                />
              </div>
            </div>

            <div class="flex items-start justify-center mt-4 gap-2">
              <img
                :src="require('~/assets/images/placeholder.svg')"
                alt="placeholder.svg"
              />

              {{ form.position.lat }}, {{ form.position.lng }}<br />
              {{ form.position.address }}
            </div>
          </div>

          <div class="border-b border-primary p-4">
            <div class="text-xl font-semibold">ตั้งเวลาเปิด-ปิดไฟ</div>

            <div class="w-4/5 mx-auto">
              <div
                class="border-b border-blue text-blue flex items-center gap-4 text-center mt-4"
              >
                <div class="flex-1">เวลาเปิดไฟ</div>

                <span class="opacity-0">-</span>

                <div class="flex-1">เวลาปิดไฟ</div>

                <img
                  v-if="form.time_list.length > 1"
                  :src="require('~/assets/images/Delete.svg')"
                  alt="Delete.svg"
                  class="opacity-0"
                />
              </div>

              <div
                v-for="(time, index) in form.time_list"
                :key="index"
                class="flex items-center gap-4 mt-4"
              >
                <input
                  type="time"
                  class="flex-1 px-3 py-1 text-black rounded-md mt-1 focus:outline-none"
                  v-model="time.open"
                />

                -

                <input
                  type="time"
                  class="flex-1 px-3 py-1 text-black rounded-md mt-1 focus:outline-none"
                  v-model="time.close"
                />

                <img
                  v-if="form.time_list.length > 1"
                  :src="require('~/assets/images/Delete.svg')"
                  alt="Delete.svg"
                  class="cursor-pointer"
                  @click="removeTime(index)"
                />
              </div>

              <button
                class="border-primary border text-primary px-8 py-1 rounded-md mt-4"
                @click="addTime"
              >
                เพิ่มเวลา
              </button>
            </div>
          </div>

          <div class="border-r border-primary p-4">
            <div class="text-xl font-semibold">ระดับความสว่าง</div>

            <img
              :src="require('~/assets/images/Group 722.svg')"
              alt="Group 722.svg"
              class="mx-auto w-10 mt-10"
            />

            <div class="flex items-center justify-center font-semibold">
              <el-slider
                v-model="form.light_step"
                class="w-3/5 mr-4"
              ></el-slider>

              {{ form.light_step }}%
            </div>
          </div>

          <div class="border-primary p-4">
            <div class="text-xl font-semibold">ใช้งานไปแล้ว</div>

            <div class="flex items-end justify-center mt-10">
              <img
                :src="require('~/assets/images/lii 1.svg')"
                alt="lii 1.svg"
              />

              <div class="text-3xl text-yellow font-semibold mx-4">
                {{ form.energy }}
              </div>

              ชั่วโมง
            </div>
          </div>
        </div>
      </template>

      <template v-if="tab === 'อัปเดตอุปกรณ์'">
        <div class="p-4">
          <div class="grid grid-cols-2 gap-20">
            <div>
              <div class="text-xl font-semibold">วิธีการเปลี่ยนหลอดไฟ</div>
            </div>

            <div>
              <div class="flex justify-between">
                <div class="text-xl font-semibold">ข้อมูลการเปลี่ยนหลอดไฟ</div>

                <div class="flex items-center gap-4">
                  <img
                    :src="require('~/assets/images/Export Pdf.svg')"
                    alt="Export Pdf.svg"
                    class="cursor-pointer"
                  />

                  <img
                    :src="require('~/assets/images/Xls Export.svg')"
                    alt="Xls Export.svg"
                    class="cursor-pointer"
                  />

                  <img
                    :src="require('~/assets/images/Export CSV.svg')"
                    alt="Export CSV.svg"
                    class="cursor-pointer"
                  />

                  <input
                    type="month"
                    v-model="month"
                    class="px-3 py-1 text-black rounded-md w-[170px] focus:outline-none"
                    @change="changeMonth"
                  />
                </div>
              </div>

              <div class="text-blue flex gap-6 mt-12">
                <div class="flex-1">ระบุซีเรียล</div>

                <div class="flex-1">วันที่และเวลาเปลี่ยนหลอดไฟ</div>
              </div>

              <div class="flex gap-6 mt-1">
                <input
                  type="text"
                  class="flex-1 px-3 py-1 text-black rounded-md mt-1 focus:outline-none"
                  v-model="changing_form.name"
                />

                <input
                  type="datetime-local"
                  class="flex-1 px-3 py-1 text-black rounded-md mt-1 focus:outline-none"
                  v-model="changing_form.datetime"
                />
              </div>

              <button
                class="border-primary border text-primary px-8 py-1 rounded-md mt-4"
                @click="addChanging"
              >
                เพิ่มข้อมูล
              </button>

              <div class="border-b border-blue text-blue flex gap-6 mt-12">
                <div class="flex-1 text-center">ระบุซีเรียล</div>

                <div class="flex-1 text-right pr-8">
                  วันที่และเวลาเปลี่ยนหลอดไฟ
                </div>
              </div>

              <div class="mb-12">
                <div
                  v-for="(changing, index) in form.changing_list"
                  :key="index"
                  class="flex gap-6 py-2"
                >
                  <div class="flex-1 text-center">{{ changing.name }}</div>

                  <div class="flex-1 text-right pr-8">
                    {{
                      moment(changing.datetime).format("DD/MM/YYYY hh:mm:ss")
                    }}
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </template>

      <template v-if="tab === 'สถิติ'">
        <div class="p-4">
          <div class="flex justify-between">
            <div class="text-xl font-semibold">กราฟสถิติการใช้ไฟฟ้า</div>

            <div class="flex items-center gap-4">
              <img
                :src="require('~/assets/images/Export Pdf.svg')"
                alt="Export Pdf.svg"
                class="cursor-pointer"
              />

              <img
                :src="require('~/assets/images/Xls Export.svg')"
                alt="Xls Export.svg"
                class="cursor-pointer"
              />

              <img
                :src="require('~/assets/images/Export CSV.svg')"
                alt="Export CSV.svg"
                class="cursor-pointer"
              />

              <div class="relative">
                <img
                  :src="require('~/assets/images/filter while 1.svg')"
                  alt="filter while 1.svg"
                  class="cursor-pointer ml-6 w-[100px]"
                  @click="show_filter = !show_filter"
                />

                <div
                  v-if="show_filter"
                  class="absolute top-10 right-0 bg-darkblue border border-primary p-4 rounded-md w-[270px] shadow"
                >
                  <div class="text-xl font-semibold text-primary">
                    กรองข้อมูล
                  </div>

                  <div class="font-light mt-4">
                    <div>เวลาเริ่มต้น</div>

                    <input
                      type="datetime-local"
                      v-model="statistic_form.start_date"
                      class="w-full px-3 py-1 text-black rounded-md mt-1 focus:outline-none"
                    />

                    <div class="mt-2">เวลาสิ้นสุด</div>

                    <input
                      type="datetime-local"
                      v-model="statistic_form.end_date"
                      class="w-full px-3 py-1 text-black rounded-md mt-1 focus:outline-none"
                    />
                  </div>

                  <button
                    class="bg-primary text-white px-8 py-1 rounded-md block mt-4 mx-auto"
                    @click="changeFilter"
                  >
                    กรอง
                  </button>
                </div>
              </div>
            </div>
          </div>

          <div class="grid grid-cols-2 mt-10 gap-20">
            <div>
              <div class="text-xl font-semibold">Energy (kWh)</div>

              <div class="h-[250px] mt-32">
                <canvas id="energy"></canvas>
              </div>
            </div>

            <div>
              <div class="text-xl font-semibold">Intensity (%)</div>

              <div class="h-[250px] mt-32">
                <canvas id="intensity"></canvas>
              </div>
            </div>
          </div>
        </div>
      </template>
    </div>

    <button
      class="bg-primary text-white px-10 py-2 text-xl rounded-md block mt-4 mx-auto"
      @click="saveForm(form)"
    >
      บันทึก
    </button>
  </div>
</template>

<script>
import Vue from "vue";
import _ from "lodash";
import { Slider, Checkbox } from "element-ui";
import Chart from "chart.js/auto";
import moment from "moment";
Vue.use(Slider);
Vue.use(Checkbox);

export default {
  props: {
    closeModal: {
      type: Function,
      default: () => {
        return {};
      },
    },
    light_data: {
      type: Array,
      default: () => {
        return [];
      },
    },
    edit_light: {
      type: Object,
      default: () => {
        return {};
      },
    },
    editLight: {
      type: Function,
      default: () => {
        return {};
      },
    },
  },
  data() {
    return {
      form: {
        name: "",
        status: false,
        hour: 0,
        energy: 0,
        date: "",
        time: "",
        light_step: 0,
        time_list: [
          {
            open: "",
            close: "",
          },
        ],
        group: {},
        position: {
          name: "",
          lat: 0,
          lng: 0,
          address: "",
        },
        statistic: {
          energy_data: [],
          intensity_data: [],
        },
      },
      search: "",
      light_options: [],
      tab: "ควบคุม",
      tab_options: ["ควบคุม", "อัปเดตอุปกรณ์", "สถิติ"],
      show_filter: false,
      statistic_form: {
        start_date: "",
        end_date: "",
      },
      changing_form: {
        name: "",
        datetime: "",
      },
      energy_chart: null,
      intensity_chart: null,
      month: moment().format("YYYY-MM"),
      moment: moment,
    };
  },
  computed: {},
  created() {
    this.setForm();
  },
  methods: {
    changeMonth: _.debounce(function () {
      console.log(this.month);
    }, 200),
    async changeTab(tab) {
      if (this.tab === tab) return;
      this.tab = tab;
      await this.$nextTick();

      if (this.tab === "สถิติ") {
        this.setEnergyChart();
        this.setIntensityChart();
      }
    },
    setEnergyChart() {
      const ctx = document.getElementById(`energy`);

      const options = {
        maintainAspectRatio: false,
        plugins: {
          tooltip: {
            enabled: false,
          },
          legend: {
            display: false,
          },
        },
        scales: {
          x: {
            grid: {
              display: false,
              drawBorder: false,
            },
          },
          y: {
            grid: {
              display: false,
              drawBorder: false,
            },
          },
        },
      };

      const data = {
        labels: _.map(this.form.statistic.energy_data, (d) => [d.date, d.time]),
        datasets: [
          {
            data: _.map(this.form.statistic.energy_data, (d) => d.value),
            borderColor: "#00D1E3",
            pointRadius: 0,
          },
        ],
      };

      const config = {
        type: "line",
        data,
        options,
      };

      Chart.defaults.font.family = "Kanit";
      Chart.defaults.font.size = 12;
      Chart.defaults.color = "white";
      Chart.defaults.font.weight = 300;
      this.energy_chart = new Chart(ctx, config);
    },
    setIntensityChart() {
      const ctx = document.getElementById(`intensity`);

      const options = {
        maintainAspectRatio: false,
        plugins: {
          tooltip: {
            enabled: false,
          },
          legend: {
            display: false,
          },
        },
        scales: {
          x: {
            grid: {
              display: false,
              drawBorder: false,
            },
          },
          y: {
            grid: {
              display: false,
              drawBorder: false,
            },
          },
        },
      };

      const data = {
        labels: _.map(this.form.statistic.intensity_data, (d) => [
          d.date,
          d.time,
        ]),
        datasets: [
          {
            data: _.map(this.form.statistic.intensity_data, (d) => d.value),
            borderColor: "#00D1E3",
            pointRadius: 0,
          },
        ],
      };

      const config = {
        type: "line",
        data,
        options,
      };

      Chart.defaults.font.family = "Kanit";
      Chart.defaults.font.size = 12;
      Chart.defaults.color = "white";
      Chart.defaults.font.weight = 300;
      this.intensity_chart = new Chart(ctx, config);
    },
    changeFilter() {
      this.show_filter = false;

      this.form.statistic.energy_data = [
        {
          value: 110,
          date: "Apr 26",
          time: "12:00",
        },
        {
          value: 210,
          date: "Apr 27",
          time: "12:00",
        },
        {
          value: 810,
          date: "Apr 28",
          time: "12:00",
        },
      ];
      this.form.statistic.intensity_data = [
        {
          value: 810,
          date: "Apr 26",
          time: "12:00",
        },
        {
          value: 210,
          date: "Apr 27",
          time: "12:00",
        },
        {
          value: 410,
          date: "Apr 28",
          time: "12:00",
        },
      ];

      this.updateChart();
    },
    updateChart() {
      // mock change data
      this.energy_chart.data.datasets = [
        {
          data: _.map(this.form.statistic.energy_data, (d) => d.value),
          borderColor: "#00D1E3",
          pointRadius: 0,
        },
      ];
      this.energy_chart.data.labels = _.map(
        this.form.statistic.energy_data,
        (d) => [d.date, d.time]
      );

      this.intensity_chart.data.datasets = [
        {
          data: _.map(this.form.statistic.intensity_data, (d) => d.value),
          borderColor: "#00D1E3",
          pointRadius: 0,
        },
      ];
      this.intensity_chart.data.labels = _.map(
        this.form.statistic.intensity_data,
        (d) => [d.date, d.time]
      );

      this.energy_chart.update();
      this.intensity_chart.update();
    },
    removeTime(index) {
      this.form.time_list.splice(index, 1);
    },
    addTime() {
      this.form.time_list.push({
        open: "",
        close: "",
      });
    },
    addChanging() {
      this.form.changing_list.push(this.changing_form);
      this.changing_form = { name: "", datetime: "" };
    },
    setForm() {
      this.form = _.cloneDeep({ ...this.form, ...this.edit_light });
    },
    saveForm(form) {
      this.editLight(form);
      this.closeModal();
    },
  },
};
</script>

<style lang="scss" scoped></style>
